/* 	server.c - was Myecho.c (comments below)
 *	now acts as a relay server between two running Smalltalk Images.
 *		Neil Haddley 3/1989
 */	

/*	Myecho.c - Example of the use of Berkeley Unix Sockets with the
 *	Smalltalk-80 Programming System Version VI 2.2/VM 1.1
 *	Compile this file and open a socket to it with the Smalltalk example 
 *	in the file Socket.st
 *		ParcPlace Systems - 7/87
 */
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORTNO_1 9876
#define PORTNO_2 9877 /* arbitrary choixe of port no but not a service(ihope) */

main (argc, argv)
	char *argv[];
	int argc;
{
	struct servent *sp;
	struct sockaddr_in prog, client;
	struct sockaddr_in prog2, client2;
	int clientsize, client2size;
	char buf[BUFSIZ];
	char line[BUFSIZ];
	char a, *b = buf;
	FILE *cfd;
	int port;
	int s, ns;
	int s2, ns2;
	int mask1,mask2,both;
	int cnt;

	cfd = fopen("/dev/console", "w");
	port = PORTNO_1;

/* Create Sockets */
	if ((s=socket(AF_INET, SOCK_STREAM, 0)) == -1)
        {
		fprintf(cfd, "Error in socket\n");
		perror("socket");
		fflush(cfd);
		exit(1);
	}
	if ((s2=socket(AF_INET, SOCK_STREAM, 0)) == -1)
        {
		fprintf(cfd, "Error in socket2 \n");
		perror("socket");
		fflush(cfd);
		exit(1);
	}

/* Bind Socket 1 */
	prog.sin_family = AF_INET;
	prog.sin_addr.s_addr = INADDR_ANY;
	prog.sin_port = PORTNO_1;

	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, 0, 0))
		perror("setsockopt");

	if (bind(s, &prog, sizeof(prog)) == -1){
		fprintf(cfd, "Error in 'bind'\nsocket= %d, prog= %d, %d\n",
				s, prog.sin_family, prog.sin_port);
		perror("bind");
		fflush(cfd);
		shutdown(s, 2);
		exit(2);
	}

/* Bind Socket 2  

	prog2.sin_family = AF_INET;
	prog2.sin_addr.s_addr = INADDR_ANY;
	prog2.sin_port =PORTNO_2;

	if (setsockopt(s2, SOL_SOCKET, SO_REUSEADDR, 0, 0))
		perror("setsockopt");

	if (bind(s2, &prog2, sizeof(prog2)) == -1){
		fprintf(cfd, "Error in 'bind'\nsocket= %d, prog= %d, %d\n",
				s, prog.sin_family, prog.sin_port);
		perror("bind");
		fflush(cfd);
		shutdown(s2, 2);
		exit(2);
	}
*/

	for (;;){
	/* Accept the conection from th the first socket */

		if (listen(s, 1) == -1) perror("listen");
		clientsize = sizeof(client);
		if ((ns = accept(s, &client, &clientsize)) == -1)
			perror("accept");
#ifdef DEBUG
		printf("\nfirst Connection");
#endif
		if (listen(s, 1) == -1) perror("listen");
		client2size = sizeof(client2);
		if ((ns2 = accept(s, &client2, &client2size)) == -1)
			perror("accept");
#ifdef DEBUG
		printf("\nsecond Connection\n");
#endif

		mask1 = 1<<ns;
		mask2 = 1<<ns2;
		
		for (;;)
		  {
		    both = mask1 | mask2;
		    if (select(32,&both,0,0,0) > 0)
			{
			if (both& mask1)
				{
				if ((cnt = recv(ns, buf, sizeof(buf), 0)) == 0) 
					{
   				 	close(ns);
				 	break;
					}
				else 
			    		{
 					buf[cnt] = 0;
					bzero(line, BUFSIZ);
					sprintf(line,"%s",buf);
#ifdef DEBUG
					printf("\n<- %s",buf);
#endif
					send(ns2, line, strlen(line), 0);
			    		}
				}

			if (both& mask2)
				{
		  		if ((cnt = recv(ns2, buf, sizeof(buf), 0)) == 0)
						{
				 		close(ns2);
				 		break;
						}
				else 
			    		{
 					buf[cnt] = 0;
					bzero(line, BUFSIZ);
#ifdef DEBUG
					printf("\n-> %s",buf);
#endif
					sprintf(line,"%s",buf);
					send(ns, line, strlen(line), 0);
			    		}
				}
			}
		   }
	}
}


